class TextRepLexer
  : public TextRepFlexLexer
{
public:
  TextRepLexer(const char* aBuf)
    : mBuf(aBuf)
  {
    mLen = strlen(aBuf);
  }

  nsCString& GetError()
  {
    return mMessage;
  }
protected:
  virtual int LexerInput(char* buf, int max_size)
  {
    if ((PRUint32)max_size > mLen)
      max_size = mLen;
    memcpy(buf, mBuf, max_size);
    mBuf += max_size;
    mLen -= max_size;
    return max_size;
  }

  virtual void LexerOutput(const char* buf, int max_size)
  {
  }

public:
  virtual void LexerError(const char* message)
  {
    mMessage = message;
  }
private:
  const char* mBuf;
  PRUint32 mLen;
  nsCString mMessage;
};
