extern "C++"
{
#include <nsStringAPI.h>
#include <nsCOMPtr.h>
#include <nsCOMArray.h>
#include <nsVoidArray.h>
#include "IMathML_content_APISPEC.h"

/* This is a really ugly hack to get our state into the class. I wish that
 * flex provided a better hook for this...
 */
class TextRepLValue;
#define yy_full_match yy_full_match; \
  public: \
    TextRepLValue* mLValue; \
    int mColumn;
#ifndef IN_LEXER
#define yyFlexLexer TextRepFlexLexer
#include <FlexLexer.h>
#undef yy_full_match
#endif

#define YYSTYPE TextRepLValue
  class TextRepLValue
  {
  public:
    nsCString mStr;
    bool mOverrideBuiltin;
    double mNumber;
    nsCOMPtr<mathml_dom_IMathMLContentElement> mMath;
    nsCStringArray mPropertyList;
    nsCOMArray<mathml_dom_IMathMLContentElement> mMathList;

    TextRepLValue&
    operator=(const TextRepLValue& aOther)
    {
      mStr = aOther.mStr;
      mOverrideBuiltin = aOther.mOverrideBuiltin;
      mNumber = aOther.mNumber;
      mMath = aOther.mMath;
      mPropertyList.Clear();
      mPropertyList = aOther.mPropertyList;
      mMathList.Clear();
      PRInt32 i;
      for (i = 0; i < aOther.mMathList.Count(); i++)
        mMathList.AppendObject(aOther.mMathList[i]);
      
      return *this;
    }
  };

  class TextRepFlexLexer;

  int textrep_lex(TextRepLValue*, TextRepFlexLexer* aLexer);
  void textrep_error(mathml_dom_IMathMLDocument*, TextRepFlexLexer* aParser, const char* aMessage);
};
