#include <windows.h>
#include <inttypes.h>
#include <stdio.h>
#define _WIN32_IE 0x400
#include <shlobj.h>

int main(int argc, char** argv)
{
  char buf[MAX_PATH], *p, *newp;
  char path[MAX_PATH];
  uint32_t lP, lB;
  FILE* f;
  STARTUPINFO si;
  PROCESS_INFORMATION proci;

  // Figure out where we are being called from...
  if (GetModuleFileName(NULL, buf, sizeof(buf)) == sizeof(buf))
    return -1;
  
  p = strrchr(buf, '\\');
  if (p != NULL)
    *p = 0;

  lB = strlen(buf);

  p = getenv("PATH");
  lP = strlen(p);
  
  if (lB > 0x8000000 || lP > 0x8000000)
    return -1;

  newp = (char*)malloc(5 + 9 + lB * 2 + lP + 2);
  memcpy(newp, buf, lB);
  memcpy(newp + lB, "\\lib;", 5);
  memcpy(newp + lB + 5, buf, lB);
  memcpy(newp + lB * 2 + 5, "\\gcc\\bin;", 9);
  memcpy(newp + lB * 2 + 5 + 9, ";", 1);
  strcpy(newp + lB * 2 + 5 + 9 + 1, p);
  SetEnvironmentVariable("PATH", newp);
  SetEnvironmentVariable("MOZILLA_FIVE_HOME", buf);
  chdir(buf);

  // Next write the configuration file...
  SHGetSpecialFolderPath(NULL, path, CSIDL_LOCAL_APPDATA, 1);
  p = path + strlen(path);
  strncpy(p, "/.cellml", sizeof(path) - (p - path) - 1);
  p[sizeof(path) - (p - path) - 1] = 0;
  mkdir(path);
  strncpy(p, "/.cellml/server_config", sizeof(path) - (p - path) - 1);
  f = fopen(path, "w");

  if (f != NULL)
  {
    fprintf(f, "load_service %s\\cellml\\CCGSService-0.dll\n",
            buf);
    fprintf(f, "load_service %s\\cellml\\CISService-0.dll\n",
            buf);
    fclose(f);
  }

  // Now launch the CellML CORBA Server...
  memset(&si, 0, sizeof(si));
  si.cb = sizeof(si);
  CreateProcess("cellml\\cellml_corba_server.exe",
		"cellml_corba_server.exe -ORBendPoint giop:tcp:127.0.0.1:0", NULL, NULL, 0,
		CREATE_NO_WINDOW, NULL, NULL, &si, &proci);

  CreateProcess("xulrunner.exe",
		"xulrunner.exe application.ini", NULL, NULL, 0,
		CREATE_NO_WINDOW, NULL, NULL, &si, &proci);
}
